## qmmp 2.2.8

=== doc/CMakeLists.txt ===
project(doc)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.cmake"
  IMMEDIATE @ONLY)

add_custom_target(docs COMMAND doxygen ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.cmake WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== src/app/CMakeLists.txt ===
project(app)

include(UsePkgConfig)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(app_SRCS
    builtincommandlineoption.cpp
    main.cpp
    qmmpstarter.cpp
    images/images.qrc
    translations/qmmp_locales.qrc
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_executable(qmmp ${app_SRCS})
target_link_libraries(qmmp PRIVATE Qt6::Widgets Qt6::Network libqmmp libqmmpui)
set_target_properties(qmmp PROPERTIES OUTPUT_NAME qmmp${APP_NAME_SUFFIX})

install(TARGETS qmmp DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES qmmp-opencda${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/solid/actions)
install(FILES qmmp${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
install(FILES images/16x16/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/16x16/apps)
install(FILES images/32x32/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/32x32/apps)
install(FILES images/48x48/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/48x48/apps)
install(FILES images/56x56/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/56x56/apps)
install(FILES images/64x64/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/64x64/apps)
install(FILES images/128x128/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/128x128/apps)
install(FILES images/256x256/qmmp${APP_NAME_SUFFIX}.png DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/256x256/apps)
install(FILES images/scalable/qmmp${APP_NAME_SUFFIX}.svgz images/scalable/qmmp-simple${APP_NAME_SUFFIX}.svgz DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
install(FILES metainfo/com.ylsoftware.qmmp${APP_NAME_SUFFIX}.metainfo.xml DESTINATION ${CMAKE_INSTALL_DATADIR}/metainfo)

if(USE_DIR_ASSOC)
    install(FILES qmmp-enqueue${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES qmmp-dir${APP_NAME_SUFFIX}.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
endif(USE_DIR_ASSOC)

=== src/plugins/CMakeLists.txt ===
set(USE_ENCA TRUE CACHE BOOL "enable/disable libenca support")
include(FindPkgConfig)
pkg_search_module(ENCA enca>=1.9 IMPORTED_TARGET)
pkg_search_module(TAGLIB taglib>=1.12 IMPORTED_TARGET)
add_subdirectory(Input)
add_subdirectory(Output)
add_subdirectory(Visual)
add_subdirectory(Effect)
add_subdirectory(General)
add_subdirectory(PlayListFormats)
add_subdirectory(CommandLineOptions)
add_subdirectory(FileDialogs)
add_subdirectory(Transports)
add_subdirectory(Engines)
add_subdirectory(Ui)

=== src/qmmp/CMakeLists.txt ===
project(libqmmp)

add_definitions(-DQMMP_LIBRARY)
set(libqmmp_DEFINES
    LIB_DIR="/${LIB_DIR}"
    QMMP_INSTALL_PREFIX="${CMAKE_INSTALL_PREFIX}"
    APP_NAME_SUFFIX="${APP_NAME_SUFFIX}"
)

if(NOT QMMP_VERSION_STABLE) #add svn revision
    execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/svn_revision.sh
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                    OUTPUT_VARIABLE SVN_REVISION
                   OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(SVN_REVISION)
        set(libqmmp_DEFINES ${libqmmp_DEFINES} SVN_REVISION="${SVN_REVISION}")
    endif(SVN_REVISION)
endif(NOT QMMP_VERSION_STABLE)

set(libqmmp_DEFINES ${libqmmp_DEFINES} QMMP_PLUGIN_DIR="${CMAKE_INSTALL_PREFIX}/${PLUGIN_DIR}")

set(QMMP_DEFAULT_OUTPUT "" CACHE STRING "default output plugin")
if(QMMP_DEFAULT_OUTPUT)
    SET(libqmmp_DEFINES ${libqmmp_DEFINES} QMMP_DEFAULT_OUTPUT="${QMMP_DEFAULT_OUTPUT}")
    MESSAGE(STATUS "Default output: ${QMMP_DEFAULT_OUTPUT}")
endif(QMMP_DEFAULT_OUTPUT)


set(libqmmp_SRCS
    visual.cpp
    recycler.cpp
    decoder.cpp
    output.cpp
    outputwriter.cpp
    trackinfo.cpp
    equ/iir.c
    equ/iir_cfs.c
    equ/iir_fpu.c
    soundcore.cpp
    effect.cpp
    qmmp.cpp
    statehandler.cpp
    volumehandler.cpp
    metadatamodel.cpp
    tagmodel.cpp
    qmmpaudioengine.cpp
    abstractengine.cpp
    audioparameters.cpp
    inputsource.cpp
    fileinputsource.cpp
    emptyinputsource.cpp
    metadatamanager.cpp
    replaygain.cpp
    qmmpsettings.cpp
    audioconverter.cpp
    eqsettings.cpp
    qmmpevents.cpp
    qmmpplugincache.cpp
    channelmap.cpp
    channelconverter.cpp
    volume.cpp
    dithering.cpp
    visualbuffer.cpp
    cueparser.cpp
    qmmptextcodec.cpp
)

SET(libqmmp_DEVEL_HDRS
    abstractengine.h
    audioconverter.h
    audioparameters.h
    buffer.h
    channelmap.h
    cueparser.h
    decoderfactory.h
    decoder.h
    effectfactory.h
    effect.h
    enginefactory.h
    eqsettings.h
    inputsourcefactory.h
    inputsource.h
    metadatamanager.h
    metadatamodel.h
    outputfactory.h
    output.h
    qmmp_export.h
    qmmp.h
    qmmpsettings.h
    qmmptextcodec.h
    soundcore.h
    statehandler.h
    tagmodel.h
    trackinfo.h
    visualfactory.h
    visual.h
    volume.h
    volumehandler.h
)

# Don't forget to include output directory, otherwise
# the UI file won't be wrapped!
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_library(libqmmp SHARED ${libqmmp_SRCS})
target_link_libraries(libqmmp PRIVATE Qt6::Widgets)
set_target_properties(libqmmp PROPERTIES VERSION ${QMMP_VERSION} SOVERSION ${QMMP_SOVERSION} OUTPUT_NAME qmmp${APP_NAME_SUFFIX})
target_compile_definitions(libqmmp PRIVATE ${libqmmp_DEFINES})
install(TARGETS libqmmp LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

#freebsd support
if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
    target_link_directories(libqmmp PRIVATE /usr/local/lib)
    target_link_libraries(libqmmp PRIVATE iconv)
endif()

if(APP_NAME_SUFFIX)
    install(FILES ${libqmmp_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX}/qmmp)
    SET(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX})
else()
    install(FILES ${libqmmp_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmp)
    SET(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmmp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/qmmp${APP_NAME_SUFFIX}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmmp${APP_NAME_SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== src/qmmpui/CMakeLists.txt ===
project(libqmmpui)

add_definitions(-DQMMPUI_LIBRARY)

set(QMMP_DEFAULT_UI "" CACHE STRING "default user interface")
if(QMMP_DEFAULT_UI)
    set(libqmmpui_DEFINES ${libqmmpui_DEFINES} QMMP_DEFAULT_UI="${QMMP_DEFAULT_OUTPUT}")
    message(STATUS "Default user interface: ${QMMP_DEFAULT_UI}")
endif(QMMP_DEFAULT_UI)


set(libqmmpui_SRCS
    general.cpp
    uihelper.cpp
    playlistparser.cpp
    commandlinemanager.cpp
    commandlinehandler.cpp
    filedialog.cpp
    qtfiledialog.cpp
    fileloader.cpp
    playstate.cpp
    playlistmodel.cpp
    playlistitem.cpp
    playlistgroup.cpp
    playlisttrack.cpp
    playlistcontainer.cpp
    normalcontainer.cpp
    groupedcontainer.cpp
    mediaplayer.cpp
    detailsdialog.cpp
    tageditor.cpp
    playlistmanager.cpp
    metadataformatter.cpp
    metadataformattermenu.cpp
    templateeditor.cpp
    uiloader.cpp
    jumptotrackdialog.cpp
    configdialog.cpp
    pluginitem.cpp
    aboutdialog.cpp
    qmmpuisettings.cpp
    radioitemdelegate.cpp
    playlistdownloader.cpp
    addurldialog.cpp
    qmmpuiplugincache.cpp
    playlisttask.cpp
    playlistheadermodel.cpp
    columneditor.cpp
    metadatahelper.cpp
    coverviewer.cpp
    covereditor.cpp
    coverloader.cpp
    generalfactory.cpp
    cueeditor.cpp
    visualmenu.cpp
    colorwidget.cpp
    shortcutdialog.cpp
    forms/detailsdialog.ui
    forms/tageditor.ui
    forms/templateeditor.ui
    forms/jumptotrackdialog.ui
    forms/configdialog.ui
    forms/aboutdialog.ui
    forms/addurldialog.ui
    forms/columneditor.ui
    forms/covereditor.ui
    forms/cueeditor.ui
    forms/shortcutdialog.ui
    translations/libqmmpui_locales.qrc
    txt/txt.qrc
    images/qmmpui_images.qrc
)

SET(libqmmpui_DEVEL_HDRS
    colorwidget.h
    commandlinehandler.h
    commandlinemanager.h
    configdialog.h
    detailsdialog.h
    filedialogfactory.h
    filedialog.h
    generalfactory.h
    general.h
    mediaplayer.h
    metadataformatter.h
    metadataformattermenu.h
    playlistdownloader.h
    playlistformat.h
    playlistgroup.h
    playlistheadermodel.h
    playlistitem.h
    playlistmanager.h
    playlistmodel.h
    playlistparser.h
    playlisttrack.h
    qmmpui_export.h
    qmmpuisettings.h
    shortcutdialog.h
    templateeditor.h
    uifactory.h
    uihelper.h
    uiloader.h
    visualmenu.h
)

include_directories(${CMAKE_CURRENT_BINARY_DIR})
set(CMAKE_AUTOUIC_SEARCH_PATHS ${CMAKE_AUTOUIC_SEARCH_PATHS} ${CMAKE_CURRENT_SOURCE_DIR}/forms)

add_library(libqmmpui SHARED ${libqmmpui_SRCS})
target_link_libraries(libqmmpui PRIVATE Qt6::Widgets Qt6::Network libqmmp)
set_target_properties(libqmmpui PROPERTIES VERSION ${QMMP_VERSION} SOVERSION ${QMMP_SOVERSION} OUTPUT_NAME qmmpui${APP_NAME_SUFFIX})
target_compile_definitions(libqmmpui PRIVATE ${libqmmpui_DEFINES})
install(TARGETS libqmmpui LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
                          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                          ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})


if(APP_NAME_SUFFIX)
    install(FILES ${libqmmpui_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX}/qmmpui)
    set(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR}/qmmp${APP_NAME_SUFFIX})
else()
    install(FILES ${libqmmpui_DEVEL_HDRS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/qmmpui)
    set(QMMP_INCLUDE_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qmmpui.pc.in ${CMAKE_CURRENT_BINARY_DIR}/qmmpui${APP_NAME_SUFFIX}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/qmmpui${APP_NAME_SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

=== src/plugins/Engines/CMakeLists.txt ===
set(USE_MPLAYER TRUE CACHE BOOL "enable/disable mplayer support")

if(USE_MPLAYER)
    add_subdirectory(mplayer)
endif(USE_MPLAYER)

=== src/plugins/General/CMakeLists.txt ===
set(USE_MPRIS TRUE CACHE BOOL "enable/disable mpris plugin")
set(USE_SCROBBLER TRUE CACHE BOOL "enable/disable scrobbler plugin")
set(USE_LISTENBRAINZ TRUE CACHE BOOL "enable/disable listenbrainz plugin")
set(USE_STATICON TRUE CACHE BOOL "enable/disable status icon plugin")
set(USE_NOTIFIER TRUE CACHE BOOL "enable/disable notifier plugin")
set(USE_LYRICS TRUE CACHE BOOL "enable/disable lyrics version")
set(USE_UDISKS TRUE CACHE BOOL "enable/disable udisks plugin")
set(USE_HOTKEY TRUE CACHE BOOL "enable/disable global hotkey plugin")
set(USE_GNOMEHOTKEY TRUE CACHE BOOL "enable/disable gnome hotkey plugin")
set(USE_FILEOPS TRUE CACHE BOOL "enable/disable fileops plugin")
set(USE_COVER TRUE CACHE BOOL "enable/disable cover manager plugin")
set(USE_KDENOTIFY TRUE CACHE BOOL "enable/disable kde notification plugin")
set(USE_CONVERTER TRUE CACHE BOOL "enable/disable audio converter plugin")
set(USE_RGSCAN TRUE CACHE BOOL "enable/disable replaygain scanner plugin")
set(USE_SB TRUE CACHE BOOL "enable/disable stream browser plugin")
set(USE_TRACKCHANGE TRUE CACHE BOOL "enable/disable track change plugin")
set(USE_COPYPASTE TRUE CACHE BOOL "enable/disable copy/paste change plugin")
set(USE_HISTORY TRUE CACHE BOOL "enable/disable history plugin")
set(USE_SLEEPINHIBITOR TRUE CACHE BOOL "enable/disable sleep mode inhibition plugin")
set(USE_LIBRARY TRUE CACHE BOOL "enable/disable media library plugin")
set(USE_TASKBAR TRUE CACHE BOOL "enable/disable taskbar plugin (Windows)")
set(USE_RDETECT TRUE CACHE BOOL "enable/disable rdetect plugin (Windows)")

if(USE_MPRIS AND Qt6DBus_FOUND)
    add_subdirectory(mpris)
endif(USE_MPRIS AND Qt6DBus_FOUND)

if(USE_SCROBBLER)
    add_subdirectory(scrobbler)
endif(USE_SCROBBLER)

if(USE_LISTENBRAINZ)
    add_subdirectory(listenbrainz)
endif(USE_LISTENBRAINZ)

if(USE_STATICON)
    add_subdirectory(statusicon)
endif(USE_STATICON)

if(USE_NOTIFIER)
    add_subdirectory(notifier)
endif(USE_NOTIFIER)

if(USE_LYRICS)
    add_subdirectory(lyrics)
endif(USE_LYRICS)

if(USE_UDISKS AND Qt6DBus_FOUND)
    add_subdirectory(udisks)
endif(USE_UDISKS AND Qt6DBus_FOUND)

if(USE_HOTKEY AND X11_FOUND)
    add_subdirectory(hotkey)
endif(USE_HOTKEY AND X11_FOUND)

if(USE_FILEOPS)
    add_subdirectory(fileops)
endif(USE_FILEOPS)

if(USE_COVER)
    add_subdirectory(covermanager)
endif(USE_COVER)

if(USE_KDENOTIFY AND Qt6DBus_FOUND)
    add_subdirectory(kdenotify)
endif(USE_KDENOTIFY AND Qt6DBus_FOUND)

if(USE_CONVERTER AND TAGLIB_FOUND)
    add_subdirectory(converter)
endif(USE_CONVERTER AND TAGLIB_FOUND)

if(USE_RGSCAN AND TAGLIB_FOUND)
    add_subdirectory(rgscan)
endif(USE_RGSCAN AND TAGLIB_FOUND)

if(USE_SB)
    add_subdirectory(streambrowser)
endif(USE_SB)

if(USE_TRACKCHANGE)
    add_subdirectory(trackchange)
endif(USE_TRACKCHANGE)

if(USE_COPYPASTE)
    add_subdirectory(copypaste)
endif(USE_COPYPASTE)

if(USE_GNOMEHOTKEY AND Qt6DBus_FOUND)
    add_subdirectory(gnomehotkey)
endif(USE_GNOMEHOTKEY AND Qt6DBus_FOUND)

if(USE_HISTORY AND Qt6Sql_FOUND)
   add_subdirectory(history)
endif(USE_HISTORY AND Qt6Sql_FOUND)

if(USE_SLEEPINHIBITOR AND Qt6DBus_FOUND)
   add_subdirectory(sleepinhibitor)
endif(USE_SLEEPINHIBITOR AND Qt6DBus_FOUND)

if(USE_TASKBAR AND WIN32)
   add_subdirectory(taskbar)
endif(USE_TASKBAR AND WIN32)

if(USE_RDETECT AND WIN32)
   add_subdirectory(rdetect)
endif(USE_RDETECT AND WIN32)

if(USE_LIBRARY AND Qt6Sql_FOUND)
    add_subdirectory(library)
endif(USE_LIBRARY AND Qt6Sql_FOUND)

=== src/plugins/Input/CMakeLists.txt ===
set(USE_MAD            TRUE CACHE BOOL "enable/disable mad decoder (mpeg plugin)")
set(USE_MPG123         TRUE CACHE BOOL "enable/disable mpg123 decoder (mpeg plugin)")
set(USE_FLAC           TRUE CACHE BOOL "enable/disable flac plugin")
set(USE_VORBIS         TRUE CACHE BOOL "enable/disable ogg vorbis plugin")
set(USE_FFMPEG         TRUE CACHE BOOL "enable/disable ffmpeg plugin")
set(USE_MPC            TRUE CACHE BOOL "enable/disable mpc plugin")
set(USE_SNDFILE        TRUE CACHE BOOL "enable/disable sndfile plugin")
set(USE_WAVPACK        TRUE CACHE BOOL "enable/disable wavpack plugin")
set(USE_XMP            TRUE CACHE BOOL "enable/disable xmp plugin")
set(USE_AAC            TRUE CACHE BOOL "enable/disable aac plugin")
set(USE_CUE            TRUE CACHE BOOL "enable/disable cue plugin")
set(USE_CDA            TRUE CACHE BOOL "enable/disable cd audio support")
set(USE_MIDI           TRUE CACHE BOOL "enable/disable midi support")
set(USE_GME            TRUE CACHE BOOL "enable/disable game music plugin")
set(USE_OPUS           TRUE CACHE BOOL "enable/disable opus plugin")
set(USE_SID            TRUE CACHE BOOL "enable/disable sid plugin")
set(USE_ARCHIVE        TRUE CACHE BOOL "enable/disable archive plugin")


if((USE_MAD OR USE_MPG123) AND TAGLIB_FOUND)
    add_subdirectory(mpeg)
endif((USE_MAD OR USE_MPG123) AND TAGLIB_FOUND)

if(USE_FLAC AND TAGLIB_FOUND)
    add_subdirectory(flac)
endif(USE_FLAC AND TAGLIB_FOUND)

if(USE_VORBIS AND TAGLIB_FOUND)
    add_subdirectory(vorbis)
endif(USE_VORBIS AND TAGLIB_FOUND)

if(USE_FFMPEG AND TAGLIB_FOUND)
    add_subdirectory(ffmpeg)
endif(USE_FFMPEG AND TAGLIB_FOUND)

if(USE_MPC AND TAGLIB_FOUND)
    add_subdirectory(mpc)
endif(USE_MPC AND TAGLIB_FOUND)

if(USE_SNDFILE)
   add_subdirectory(sndfile)
endif(USE_SNDFILE)

if(USE_WAVPACK)
    add_subdirectory(wavpack)
endif(USE_WAVPACK)

if(USE_XMP)
   add_subdirectory(xmp)
endif(USE_XMP)

if(USE_AAC AND TAGLIB_FOUND)
   add_subdirectory(aac)
endif(USE_AAC AND TAGLIB_FOUND)

if(USE_CUE)
add_subdirectory(cue)
endif(USE_CUE)

if(USE_CDA)
add_subdirectory(cdaudio)
endif(USE_CDA)

if(USE_MIDI)
add_subdirectory(wildmidi)
endif(USE_MIDI)

if(USE_GME)
    add_subdirectory(gme)
endif(USE_GME)

if(USE_OPUS AND TAGLIB_FOUND)
    add_subdirectory(opus)
endif(USE_OPUS AND TAGLIB_FOUND)

if(USE_SID)
    add_subdirectory(sid)
endif(USE_SID)

if(USE_ARCHIVE AND TAGLIB_FOUND)
    add_subdirectory(archive)
endif(USE_ARCHIVE AND TAGLIB_FOUND)

=== src/plugins/Output/CMakeLists.txt ===
set(USE_ALSA TRUE CACHE BOOL "enable/disable alsa plugin")
set(USE_JACK TRUE CACHE BOOL "enable/disable jack plugin")
set(USE_OSS FALSE CACHE BOOL "enable/disable oss plugin")
set(USE_OSS4 TRUE CACHE BOOL "enable/disable oss4 plugin")
set(USE_PULSE TRUE CACHE BOOL "enable/disable pulseaudio plugin")
set(USE_PIPEWIRE TRUE CACHE BOOL "enable/disable pipewire plugin")
set(USE_NULL TRUE CACHE BOOL "enable/disable null output plugin")
set(USE_WAVEOUT TRUE CACHE BOOL "enable/disable Win32 waveout plugin")
set(USE_DSOUND TRUE CACHE BOOL "enable/disable DirectSound plugin")
set(USE_QTMULTIMEDIA TRUE CACHE BOOL "enable/disable Qt Multimedia output plugin")
set(USE_WASAPI TRUE CACHE BOOL "enable/disable WASAPI plugin")
set(USE_SHOUT TRUE CACHE BOOL "enable/disable Icecast plugin")

if(USE_ALSA)
    add_subdirectory(alsa)
endif(USE_ALSA)

if(USE_JACK)
    add_subdirectory(jack)
endif(USE_JACK)

if(USE_OSS)
    add_subdirectory(oss)
endif(USE_OSS)

if(USE_OSS4)
    add_subdirectory(oss4)
endif(USE_OSS4)

if(USE_PULSE)
    add_subdirectory(pulseaudio)
endif(USE_PULSE)

if(USE_PIPEWIRE)
    add_subdirectory(pipewire)
endif(USE_PIPEWIRE)

if(USE_NULL)
    add_subdirectory(null)
endif(USE_NULL)

if(USE_WAVEOUT)
    add_subdirectory(waveout)
endif(USE_WAVEOUT)

if(USE_DSOUND)
    add_subdirectory(directsound)
endif(USE_DSOUND)

if(USE_QTMULTIMEDIA AND Qt6Multimedia_FOUND)
    add_subdirectory(qtmultimedia)
endif(USE_QTMULTIMEDIA AND Qt6Multimedia_FOUND)

if(USE_WASAPI)
    add_subdirectory(wasapi)
endif(USE_WASAPI)

if(USE_SHOUT)
    add_subdirectory(shout)
endif(USE_SHOUT)

=== src/plugins/Ui/CMakeLists.txt ===
set(USE_SKINNED TRUE CACHE BOOL "enable/disable skinned user interface")
set(USE_QSUI TRUE CACHE BOOL "enable/disable simple user interface (qsui)")

if(USE_SKINNED AND SKINNED_AVAILABLE)
    add_subdirectory(skinned)
endif(USE_SKINNED AND SKINNED_AVAILABLE)

if(USE_QSUI)
    add_subdirectory(qsui)
endif(USE_QSUI)

=== src/plugins/CommandLineOptions/IncDecVolumeOption/CMakeLists.txt ===
project(libincdecvolumeoption)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(libincdecvolumeoption_SRCS
    incdecvolumeoption.cpp
    translations/translations.qrc
)

add_library(incdecvolumeoption MODULE ${libincdecvolumeoption_SRCS})
target_link_libraries(incdecvolumeoption PRIVATE Qt6::Widgets libqmmpui libqmmp)
install(TARGETS incdecvolumeoption DESTINATION ${PLUGIN_DIR}/CommandLineOptions)

=== src/plugins/CommandLineOptions/PlayListOption/CMakeLists.txt ===
project(libplaylistoption)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(libplaylistoption_SRCS
    playlistoption.cpp
    translations/translations.qrc
)

add_library(playlistoption MODULE ${libplaylistoption_SRCS})
target_link_libraries(playlistoption PRIVATE Qt6::Widgets libqmmpui libqmmp)
install(TARGETS playlistoption DESTINATION ${PLUGIN_DIR}/CommandLineOptions)

=== debian/changelog ===
qmmp (2.2.8-1) unstable; urgency=medium

  [ Harald Dunkel ]
  * new upstream version 2.2.8

  [ Matteo Cypriani ]
  * Depend on liboss4-salsa-dev instead of oss4-dev (Closes: #1111849)

 -- Matteo Cypriani <mcy@lm7.fr>  Sun, 24 Aug 2025 17:29:06 +0200

=== debian/control ===
Source: qmmp
Section: sound
Priority: optional
Maintainer: Matteo Cypriani <mcy@lm7.fr>
Uploaders: Harald Dunkel <harri@afaics.de>
Build-Depends: debhelper-compat (= 13),
  cmake,
  libarchive-dev,
  libasound2-dev [linux-any],
  libavcodec-dev,
  libavformat-dev,
  libbs2b-dev,
  libcddb2-dev,
  libcdio-dev,
  libcdio-paranoia-dev,
  libcurl4-gnutls-dev,
  libenca-dev,
  libfaad-dev,
  libflac-dev,
  libgme-dev,
  libjack-jackd2-dev,
  libmad0-dev,
  libmms-dev,
  libmpcdec-dev,
  libogg-dev,
  libopus-dev,
  libopusfile-dev,
  liboss4-salsa-dev [!linux-any],
  libpipewire-0.3-dev,
  libprojectm-dev [!armel !armhf !hurd-any],
  libpulse-dev,
  libqt6opengl6-dev,
  librcd-dev,
  libshout-dev,
  libsidplayfp-dev,
  libsndfile1-dev,
  libsoxr-dev,
  libtag-dev,
  libvorbis-dev,
  libwavpack-dev,
  libwildmidi-dev,
  libx11-dev,
  libxmp-dev,
  pkgconf,
  qt6-base-dev,
  qt6-multimedia-dev,
  qt6-tools-dev,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://qmmp.ylsoftware.com/
Vcs-Git: https://salsa.debian.org/debian/qmmp.git
Vcs-Browser: https://salsa.debian.org/debian/qmmp

Package: qmmp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: qmmp-plugin-projectm, ffmpeg, mplayer, unzip, udisks2 [linux-any]
Recommends: freepats
Replaces: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
Breaks: libqmmp0 (<< 0.8), libqmmpui0 (<< 0.8), libqmmp-misc (<< 0.8)
Description: feature-rich audio player with support of many formats
 Qmmp is feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 Supported formats:
  - MPEG1 layer 2/3
  - Ogg Vorbis
  - Ogg Opus
  - Native FLAC, Ogg FLAC
  - Musepack
  - WavePack
  - tracker modules (mod, s3m, it, xm, etc)
  - ADTS AAC
  - CD Audio
  - WMA, Monkey's Audio (and other formats provided by FFmpeg library)
  - PCM WAVE (and other formats provided by libsndfile library)
  - midi
  - SID
  - chiptune formats (AY, GBS, GYM, HES, KSS, NSF, NSFE, SAP, SPC, VGM, VGZ,
    VTX)
 .
 DSP effects:
  - BS2B effect
  - sample rate converter
  - LADSPA effects
  - extra stereo
  - crossfade
 .
 Visual effects:
  - projectM visualization
  - spectrum analyzer
 .
 Audio output through:
  - ALSA
  - OSS
  - Pulse Audio
  - PipeWire
  - JACK
  - QTMultimedia
  - Icecast
 .
 Other features:
  - XMMS and Winamp 2.x skins support
  - alternative user interface based on standard widgets set
  - 10-band equalizer
  - MP3, Vorbis, AAC, AAC+ streams support
  - mms support
  - MPRIS
  - removable device detection (via UDisks)
  - video playback via Mplayer
  - lyrics
  - cover art support
  - CUE sheet support
  - embedded CUE support (for FLAC, WavPack and Monkey's Audio)
  - multiple playlists
  - automatic charset detection for cue files and ShoutCast metadata
  - playlist formats: m3u, pls, xspf
  - ReplayGain support
  - sending listening history to Last.fm, Libre.fm and ListenBrainz
  - CDDB support
  - audio converter
  - stream browser
  - audio formats converter
  - external programs execution on track change
  - ReplayGain scanner
  - archive reader (RAR and 7z)
  - audio recording
  - listening history
  - media library

Package: qmmp-plugin-projectm
Architecture: any-amd64 any-arm64 i386 any-mips64el any-mipsel any-ppc64el any-s390x any-alpha any-hppa any-ia64 kfreebsd-any any-m68k any-powerpc any-ppc64 any-riscv64 any-sh4 any-sparc64 any-x32
Depends: ${misc:Depends}, ${shlibs:Depends}, fonts-dejavu-core
Description: qmmp audio player -- projectM visualization plugin
 Qmmp is feature-rich audio player with support of many formats.
 It is written in Qt.
 .
 See 'qmmp' package for full description.
 .
 This package contains projectM visualization plugin for qmmp.

=== debian/watch ===
version=4
https://qmmp.ylsoftware.com/files/@PACKAGE@/@ANY_VERSION@/ \
  @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
